<!--- www.instantcoldfusion.com

Description: A custom function to get the Macromedia Resource Feed

Entering: N/A
Exiting: N/A

Dependencies: N/A
Expecting: N/A

Modification History
Date       Modifier                Modification
******************************************************
00/00/2002 Jeff Houser, DotComIt   Created
--->


<!--- Define the custom function to get the resource feed --->
<cffunction name="GetMacromediaXMLResourceFeed" >

	<!--- get the xml news feed --->
	<CFHTTP url="http://www.macromedia.com/desdev/resources/macromedia_resources.xml" method="GET">
	</CFHTTP>


	<!--- return the news feed --->
	<cfreturn #XMLParse(ListRest(cfhttp.FileContent,">"))#>
</cffunction>

<cfscript>
	// this function will translate the resourcefeed from XML to a ColdFusion query 
	// Will create a query, with these fields: Type, Title, Author, URL, ProductName
	
	function TranslateResourceFeed(S){
	
		// Create the Query
		var ResultQuery = QueryNew("Type, Title, Author, URL, ProductName");

		// Get a pointer to the Resource Array
		var MacromediaResources = S.macromedia_resources.resource;
		
		// This will be a pointer to the Product Names used in the loop
		var ProductNames = "";
		
		// Loop Counter Variables
		var ResourceIndex= 1;
		var ProductIndex = 1;

		// Var RowNumber for use of keeping track of current record
		var RowNumber = 0;		

		for (ResourceIndex =1; 
		     ResourceIndex LTE ArrayLen(MacromediaResources ); 
			 ResourceIndex=ResourceIndex+1) {

			ProductNames =  MacromediaResources[ResourceIndex].product;
			
			for (ProductIndex =1; 
			     ProductIndex LTE ArrayLen(ProductNames ); 
				 ProductIndex=ProductIndex+1) {

				// add a new row to the query 
				RowNumber = QueryAddRow(ResultQuery);
				
				// populate Query 
				QuerySetCell(ResultQuery, "Type", MacromediaResources[ResourceIndex].XMLAttributes.Type, RowNumber);
				QuerySetCell(ResultQuery, "Title", MacromediaResources[ResourceIndex].title.XMLNodes[1].XMLValue, RowNumber);
				QuerySetCell(ResultQuery, "Author", MacromediaResources[ResourceIndex].author.XMLNodes[1].XMLValue, RowNumber);
				QuerySetCell(ResultQuery, "URL", MacromediaResources[ResourceIndex].url.XMLNodes[1].XMLValue, RowNumber);
				QuerySetCell(ResultQuery, "ProductName", ProductNames[ProductIndex].XMLAttributes.Name, RowNumber);
			}
		}
		Return ResultQuery;
	}
</cfscript>

<cfoutput>
	<cfset MyName = #TranslateResourceFeed(GetMacromediaXMLResourceFeed())#>
	
	<cfdump var="#MyName#">	
 
</cfoutput>